/* Events: Sample, Zero Crossings, Relations, Discrete Changes */
#include "FmuExportCrossCompile_model.h"
#if defined(__cplusplus)
extern "C" {
#endif

/* Initializes the raw time events of the simulation using the now
   calcualted parameters. */
void FmuExportCrossCompile_function_initSample(DATA *data, threadData_t *threadData)
{
  long i=0;
}

const char *FmuExportCrossCompile_zeroCrossingDescription(int i, int **out_EquationIndexes)
{
  static const char *res[] = {"h <= 0.0"};
  static const int occurEqs0[] = {1,8};
  static const int *occurEqs[] = {occurEqs0};
  *out_EquationIndexes = (int*) occurEqs[i];
  return res[i];
}

/* forwarded equations */
extern void FmuExportCrossCompile_eqFunction_10(DATA* data, threadData_t *threadData);
extern void FmuExportCrossCompile_eqFunction_11(DATA* data, threadData_t *threadData);

int FmuExportCrossCompile_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->callStatistics.functionZeroCrossingsEquations++;

  FmuExportCrossCompile_eqFunction_10(data, threadData);

  FmuExportCrossCompile_eqFunction_11(data, threadData);
  
  TRACE_POP
  return 0;
}

int FmuExportCrossCompile_function_ZeroCrossings(DATA *data, threadData_t *threadData, double *gout)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;

  modelica_boolean tmp0;
  modelica_real tmp1;
  modelica_real tmp2;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_ZC);
#endif
  data->simulationInfo->callStatistics.functionZeroCrossings++;

  tmp1 = 1.0;
  tmp2 = 0.0;
  tmp0 = LessEqZC((data->localData[0]->realVars[0] /* h STATE(1,v) */), 0.0, tmp1, tmp2, data->simulationInfo->storedRelations[0]);
  gout[0] = (tmp0) ? 1 : -1;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_ZC);
#endif

  TRACE_POP
  return 0;
}

const char *FmuExportCrossCompile_relationDescription(int i)
{
  const char *res[] = {"h <= 0.0"};
  return res[i];
}

int FmuExportCrossCompile_function_updateRelations(DATA *data, threadData_t *threadData, int evalforZeroCross)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;

  modelica_boolean tmp3;
  modelica_real tmp4;
  modelica_real tmp5;
  
  if(evalforZeroCross) {
    tmp4 = 1.0;
    tmp5 = 0.0;
    tmp3 = LessEqZC((data->localData[0]->realVars[0] /* h STATE(1,v) */), 0.0, tmp4, tmp5, data->simulationInfo->storedRelations[0]);
    data->simulationInfo->relations[0] = tmp3;
  } else {
    data->simulationInfo->relations[0] = ((data->localData[0]->realVars[0] /* h STATE(1,v) */) <= 0.0);
  }
  
  TRACE_POP
  return 0;
}

#if defined(__cplusplus)
}
#endif

