/* Simulation code for FmuExportCrossCompile generated by the OpenModelica Compiler OMCompiler v1.23.0-dev.162+g46cd0f23da. */
#if !defined(FmuExportCrossCompile__MODEL_H)
#define FmuExportCrossCompile__MODEL_H

#include "openmodelica.h"
#include "openmodelica_func.h"
#include "simulation_data.h"
#include "simulation/simulation_info_json.h"
#include "simulation/simulation_runtime.h"
#include "util/omc_error.h"
#include "util/parallel_helper.h"
#include "simulation/jacobian_util.h"
#include "simulation/simulation_omc_assert.h"
#include "simulation/solver/model_help.h"
#include "simulation/solver/delay.h"
#include "simulation/solver/linearSystem.h"
#include "simulation/solver/nonlinearSystem.h"
#include "simulation/solver/mixedSystem.h"
#include "simulation/solver/spatialDistribution.h"

#if defined(__cplusplus)
extern "C" {
#endif

#include <string.h>

#include "FmuExportCrossCompile_functions.h"


extern void FmuExportCrossCompile_callExternalObjectDestructors(DATA *_data, threadData_t *threadData);
#if !defined(OMC_NUM_NONLINEAR_SYSTEMS) || OMC_NUM_NONLINEAR_SYSTEMS>0
#endif
#if !defined(OMC_NUM_LINEAR_SYSTEMS) || OMC_NUM_LINEAR_SYSTEMS>0
#endif
#if !defined(OMC_NUM_MIXED_SYSTEMS) || OMC_NUM_MIXED_SYSTEMS>0
#endif
#if !defined(OMC_NO_STATESELECTION)
extern void FmuExportCrossCompile_initializeStateSets(int nStateSets, STATE_SET_DATA* statesetData, DATA *data);
#endif
extern int FmuExportCrossCompile_functionAlgebraics(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_function_storeDelayed(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_function_storeSpatialDistribution(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_function_initSpatialDistribution(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_updateBoundVariableAttributes(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_functionInitialEquations(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_functionInitialEquations_lambda0(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_functionRemovedInitialEquations(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_updateBoundParameters(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_checkForAsserts(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_function_ZeroCrossings(DATA *data, threadData_t *threadData, double* gout);
extern int FmuExportCrossCompile_function_updateRelations(DATA *data, threadData_t *threadData, int evalZeroCross);
extern const char* FmuExportCrossCompile_zeroCrossingDescription(int i, int **out_EquationIndexes);
extern const char* FmuExportCrossCompile_relationDescription(int i);
extern void FmuExportCrossCompile_function_initSample(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_initialAnalyticJacobianG(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int FmuExportCrossCompile_initialAnalyticJacobianA(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int FmuExportCrossCompile_initialAnalyticJacobianB(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int FmuExportCrossCompile_initialAnalyticJacobianC(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int FmuExportCrossCompile_initialAnalyticJacobianD(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int FmuExportCrossCompile_initialAnalyticJacobianF(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int FmuExportCrossCompile_initialAnalyticJacobianH(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int FmuExportCrossCompile_functionJacG_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int FmuExportCrossCompile_functionJacA_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int FmuExportCrossCompile_functionJacB_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int FmuExportCrossCompile_functionJacC_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int FmuExportCrossCompile_functionJacD_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int FmuExportCrossCompile_functionJacF_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int FmuExportCrossCompile_functionJacH_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern const char* FmuExportCrossCompile_linear_model_frame(void);
extern const char* FmuExportCrossCompile_linear_model_datarecovery_frame(void);
extern int FmuExportCrossCompile_mayer(DATA* data, modelica_real** res, short *);
extern int FmuExportCrossCompile_lagrange(DATA* data, modelica_real** res, short *, short *);
extern int FmuExportCrossCompile_pickUpBoundsForInputsInOptimization(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt);
extern int FmuExportCrossCompile_setInputData(DATA *data, const modelica_boolean file);
extern int FmuExportCrossCompile_getTimeGrid(DATA *data, modelica_integer * nsi, modelica_real**t);
extern void FmuExportCrossCompile_function_initSynchronous(DATA * data, threadData_t *threadData);
extern void FmuExportCrossCompile_function_updateSynchronous(DATA * data, threadData_t *threadData, long base_idx);
extern int FmuExportCrossCompile_function_equationsSynchronous(DATA * data, threadData_t *threadData, long base_idx, long sub_idx);
extern void FmuExportCrossCompile_read_input_fmu(MODEL_DATA* modelData, SIMULATION_INFO* simulationData);
extern void FmuExportCrossCompile_function_savePreSynchronous(DATA *data, threadData_t *threadData);
extern int FmuExportCrossCompile_inputNames(DATA* data, char ** names);
extern int FmuExportCrossCompile_dataReconciliationInputNames(DATA* data, char ** names);
extern int FmuExportCrossCompile_dataReconciliationUnmeasuredVariables(DATA* data, char ** names);
extern int FmuExportCrossCompile_initializeDAEmodeData(DATA *data, DAEMODE_DATA*);
extern int FmuExportCrossCompile_functionLocalKnownVars(DATA* data, threadData_t* threadData);
extern int FmuExportCrossCompile_symbolicInlineSystem(DATA* data, threadData_t* threadData);

#include "FmuExportCrossCompile_literals.h"




#if defined(HPCOM) && !defined(_OPENMP)
  #error "HPCOM requires OpenMP or the results are wrong"
#endif
#if defined(_OPENMP)
  #include <omp.h>
#else
  /* dummy omp defines */
  #define omp_get_max_threads() 1
#endif

#if defined(__cplusplus)
}
#endif

#endif /* !defined(FmuExportCrossCompile__MODEL_H) */


